import { Construct } from "constructs";
export declare namespace Ctor {
    type Self = Ctor;
    export type Make<Args extends any[], Instance extends Construct> = new (...args: Args) => Instance;
    export namespace Root {
        type Make<Props, Instance extends Construct> = Ctor.Make<[props: Props], Instance>;
        type Props<Ctor extends Root> = ConstructorParameters<Ctor>[0];
    }
    export type Root = Root.Make<any, Construct>;
    export namespace Child {
        type Make<Scope extends Construct, Props, Instance extends Construct> = Ctor.Make<[
            scope: Scope,
            id: string,
            props: Props
        ], Instance>;
        type Props<Ctor extends Child> = ConstructorParameters<Ctor>[2];
    }
    export type Child = Child.Make<Construct, any, Construct>;
    export type IsRoot<Ctor extends Self> = Ctor extends Child ? ConstructorParameters<Ctor> extends [] ? true : false : Ctor extends Root ? true : never;
    export type Props<Ctor extends Self> = IsRoot<Ctor> extends true ? Root.Props<Ctor> : Child.Props<Ctor>;
    export {};
}
export declare type Ctor = Ctor.Make<any[], Construct>;
